import es
import popuplib
import serverlib
import msglib
import cfglib
import langlib
import playerlib
import usermsg
from configobj import ConfigObj

apath = es.getAddonPath('serverjumper')
serverlist = ConfigObj(apath + "/serverlist.ini")
config = cfglib.AddonCFG(apath + "/settings.cfg")
config.text("**************************")
config.text("   ServerJumper Settings  ")
config.text("**************************")
sj_force = config.cvar("sj_force",   "!servers", "Set the ServerJumper Force Command")
sj_vote_time = config.cvar("sj_vote_time",   30, "How long want you to show the Server Ask Messsage (F3)")
sj_allow_advertisment = config.cvar("sj_allow_advertisment",   1, "Allow Advertisment on round_start")
sj_advertisment_type = config.cvar("sj_advertisment_type",   2, "1 = Text form, 2 = Hudhint form")
config.write()

serverDict = {}
playersChoice = {}

################################Addon Infos##########################################
info = es.AddonInfo()                                                               #
info.name          = 'ServerJumper'                                                 #
info.version       = '1.0 A'                                                        #
info.basename      = 'server_jumper'                                                #
info.url           = 'http://addons.eventscripts.com/addons/view/ServerJumper2'      #
info.author        = 'RoOF'                                                         #
es.ServerVar(info.basename, info.version, 'ServerJumper').makepublic()              #
#####################################################################################


def load():
	global text
	text = langlib.Strings(apath + "/strings.ini")
	config.execute()
	for x in serverlist:
		ip = serverlist[x]['ip']
		port = serverlist[x]['port']
		server_ip = str(ip+':'+port)
		try: 
			serverConnected = serverlib.SourceServer(ip, int(port), 5) 
			serverDetails = serverConnected.getDetails()     
			serverDict[server_ip] = {}
			serverDict[server_ip] = serverDetails
			serverConnected.disconnect() 
			es.dbgmsg(0, "[ServerJumper] Succsessfully Connected to "+str(x))
		except: 
			raise NotImplementedError, ("[ServerJumper] Sorry we are not able to Connect to the Server with the Adress: "+server_ip)
			
def unload():
	serverDict.clear()
	playersChoice.clear()
			
			
def player_say(ev):
	if ev['text'] == sj_force:
		popup(ev['userid'])
		
def round_start(ev):
	if sj_allow_advertisment == 1:
		for userid in es.getUseridList():
			if sj_advertisment_type == 1:
				es.tell(userid, '#multi', text('advert',{'v1': sj_force},playerlib.getPlayer(userid).get('lang')))
			if sj_advertisment_type == 2:
				usermsg.hudhint(userid, '[ServerJumper] You want to see our other Servers? Type '+str(sj_force)+' into the chat!')
		
			
def popup(userid):
	serverMenu = popuplib.easymenu('serverMenu2', None, servermenu_select)
	serverMenu.settitle("->ServerJumper Menu:")
	for x in serverDict:
		serverMenu.addoption((serverDict[x], x), serverDict[x]['server name'])
	serverMenu.send(userid)
	
	
	
def servermenu_select(userid, choice, popupid):
	serverMenu2 = popuplib.create('serverMenu2')
	server_ip = str(choice[1])
	serverMenu2.addline('Server Informations:')
	serverMenu2.addline('-----------------------------')
	serverMenu2.addline('Hostname: '+str(choice[0]['server name']))
	serverMenu2.addline('Current Map: '+str(choice[0]['map']))
	serverMenu2.addline('Players: '+str(choice[0]['number of players'])+'/'+str(choice[0]['maximum players']))
	serverMenu2.addline('  - > Bots Online: '+str(choice[0]['number of bots']))
	serverMenu2.addline('Ip: '+str(server_ip))
	if choice[0]['secure'] == 1:
		serverMenu2.addline('Secured: Yes')
	else:
		serverMenu2.addline('Secured: No')
	if choice[0]['password'] == 1:
		serverMenu2.addline('Password: Yes')
	else:
		serverMenu2.addline('Password: No')
	serverMenu2.addline('-----------------------------')
	serverMenu2.addline('->1. Connect to this Server NOW')
	serverMenu2.addline('-----------------------------')
	serverMenu2.addline('->8. Back')
	serverMenu2.addline('0. Exit')
	serverMenu2.send(userid) 
	serverMenu2.menuselect = servermenu_select2
	if userid not in playersChoice:
		playersChoice[userid] = 0
	playersChoice[userid] = str(choice[1])
	
def servermenu_select2(userid, choice, popupid):
	if choice == 1:
		if userid in playersChoice:
			msglib.VguiDialog(title=playersChoice[userid], time=sj_vote_time, mode=msglib.VguiMode.ASKCONNECT).send(userid)
			es.tell(userid, '#multi', text('accept',{},playerlib.getPlayer(userid).get('lang')))
	elif choice == 8:
		popup(userid)
		
def player_disconnect(ev):
	userid = ev['userid']
	if userid in playersChoice:
		del playersChoice[userid]
	
	